﻿#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>
#include <string>
using namespace std;

typedef int (WINAPI *VeryPDF_PSToPDFAFunc)(LPCTSTR lpwCommand);
VeryPDF_PSToPDFAFunc VeryPDF_PSToPDFA = NULL;

typedef int (WINAPI *VeryPDF_PSToPDFWFunc)(LPCWSTR lpwCommand);
VeryPDF_PSToPDFWFunc VeryPDF_PSToPDFW = NULL;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileNameA(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL ConvertPS2PDF(LPCWSTR lpCmd)
{
	char path[_MAX_PATH];
	HINSTANCE hPS2PDF = NULL;
	BOOL bRet;

	#ifdef _WIN64
	GetModulePath(path,"ps2pdf_x64.dll");
	#else
	GetModulePath(path,"ps2pdf_x86.dll");
	#endif

	printf("LoadLibrary(\"%s\")\n", path);
	hPS2PDF = LoadLibraryA(path);
	if(hPS2PDF == NULL)
	{
		printf("Load '%s' file failed.\n", path);
		return FALSE;
	}
	printf("Load '%s' file successful.\n", path);

	VeryPDF_PSToPDFW = (VeryPDF_PSToPDFWFunc)GetProcAddress(hPS2PDF,"VeryPDF_PSToPDFW");
	if (VeryPDF_PSToPDFW == NULL)
		return FALSE;
	VeryPDF_PSToPDFA = (VeryPDF_PSToPDFAFunc)GetProcAddress(hPS2PDF,"VeryPDF_PSToPDF");
	if (VeryPDF_PSToPDFA == NULL)
		return FALSE;

	printf("Get 'VeryPDF_PSToPDF' function successful.\n");
	bRet = VeryPDF_PSToPDFW(lpCmd);
	return bRet;
}

std::wstring strtowstr(const std::string str)
{
    // Convert an ASCII string to a Unicode String
	int nLength = str.length()*2+1;
    std::wstring wstrTo;
    wchar_t *wszTo = new wchar_t[nLength];
    memset(wszTo, 0, sizeof(wchar_t)*nLength);
    MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, wszTo, (int)nLength);
    wstrTo = wszTo;
    delete[] wszTo;
    return wstrTo;
}

/*
void _tmain(int argc, wchar_t *argv[]) 
{
	if(argc < 2)
	{
		printf("test.exe C:\\test.ps\n");
		printf("test.exe C:\\test.ps C:\\test.pdf\n");
		return;
	}
	wchar_t *lpLicenseKey = L"XXXXXXXXXXXXXXXX";
	wchar_t szCommandLine[2048] = {0};

	swprintf(szCommandLine, L"ps2pdf -$ \"%s\" ", lpLicenseKey);
	for(int i = 1; i < argc; i++)
	{
		wcscat(szCommandLine, L" \"");
		wcscat(szCommandLine, argv[i]);
		wcscat(szCommandLine, L"\"");
	}
	//int nRet = VeryPDF_PSToPDF(szCommandLine);
	int nRet = ConvertPS2PDF(szCommandLine);
	printf("nRet = %d\n", nRet);
}
*/
void main(int argc, char *argv[])
{
	if(argc < 2)
	{
		printf("test.exe C:\\test.ps\n");
		printf("test.exe C:\\test.ps C:\\test.pdf\n");
		return;
	}
	char *lpLicenseKey = "XXXXXXXXXXXXXXXX";
	char szCommandLine[2048] = {0};

	sprintf(szCommandLine,"ps2pdf -$ \"%s\" ", lpLicenseKey);
	for(int i = 1; i < argc; i++)
	{
		strcat(szCommandLine, " \"");
		strcat(szCommandLine, argv[i]);
		strcat(szCommandLine, "\"");
	}
	int nRet = 0;
	//nRet = VeryPDF_PSToPDF(szCommandLine);
	//nRet = ConvertPS2PDF(strtowstr(szCommandLine).c_str());
	ConvertPS2PDF(L"ps2pdf -$ XXXXXXXXXXXXXX \"D:/downloads/VC++_call_dll/אתה משוגע/אתה משוגע/{3b504298-f53d-4da9-9cec-3c30d81ac986}.ps\" \"D:/downloads/VC++_call_dll/אתה משוגע/אתה משוגע/{3b504298-f53d-4da9-9cec-3c30d81ac986}.pdf\"");
	printf("nRet = %d\n", nRet);
}
